diff --git src/bin/scripts/vacuumdb.c src/bin/scripts/vacuumdb.c
index 887fa48fbd..e4a63811c5 100644
--- src/bin/scripts/vacuumdb.c
+++ src/bin/scripts/vacuumdb.c
@@ -948,7 +948,7 @@ init_slot(ParallelSlot *slot, PGconn *conn, const char *progname)
 	slot->isFree = true;
 	slot->sock = PQsocket(conn);
 
-	if (slot->sock < 0)
+	if (slot->sock == PGINVALID_SOCKET || slot->sock < 0)
 	{
 		fprintf(stderr, _("%s: invalid socket: %s"), progname,
 				PQerrorMessage(conn));
